<!-- <!DOCTYPE html> -->
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>AdminLTE 3 | Invoice</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <!-- UserList style -->
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">

</head>
<body class="hold-transition sidebar-mini">
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="index3.html" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Contact</a>
      </li>
    </ul>

    <!-- Right navbar links -->
    <ul class="navbar-nav ml-auto">
      <!-- Navbar Search -->
      <li class="nav-item">
        <a class="nav-link" data-widget="navbar-search" href="#" role="button">
          <i class="fas fa-search"></i>
        </a>
        <div class="navbar-search-block">
          <form class="form-inline">
            <div class="input-group input-group-sm">
              <input class="form-control form-control-navbar" type="search" placeholder="Search" aria-label="Search">
              <div class="input-group-append">
                <button class="btn btn-navbar" type="submit">
                  <i class="fas fa-search"></i>
                </button>
                <button class="btn btn-navbar" type="button" data-widget="navbar-search">
                  <i class="fas fa-times"></i>
                </button>
              </div>
            </div>
          </form>
        </div>
      </li>

      <!-- Messages Dropdown Menu -->
      <li class="nav-item dropdown">
        <a class="nav-link" data-toggle="dropdown" href="#">
          <i class="far fa-comments"></i>
          <span class="badge badge-danger navbar-badge">3</span>
        </a>
        <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
          <a href="#" class="dropdown-item">
            <!-- Message Start -->
            <div class="media">
              <img src="dist/img/user1-128x128.jpg" alt="User Avatar" class="img-size-50 mr-3 img-circle">
              <div class="media-body">
                <h3 class="dropdown-item-title">
                  Brad Diesel
                  <span class="float-right text-sm text-danger"><i class="fas fa-star"></i></span>
                </h3>
                <p class="text-sm">Call me whenever you can...</p>
                <p class="text-sm text-muted"><i class="far fa-clock mr-1"></i> 4 Hours Ago</p>
              </div>
            </div>
            <!-- Message End -->
          </a>
          <div class="dropdown-divider"></div>
          <a href="#" class="dropdown-item">
            <!-- Message Start -->
            <div class="media">
              <img src="dist/img/user8-128x128.jpg" alt="User Avatar" class="img-size-50 img-circle mr-3">
              <div class="media-body">
                <h3 class="dropdown-item-title">
                  John Pierce
                  <span class="float-right text-sm text-muted"><i class="fas fa-star"></i></span>
                </h3>
                <p class="text-sm">I got your message bro</p>
                <p class="text-sm text-muted"><i class="far fa-clock mr-1"></i> 4 Hours Ago</p>
              </div>
            </div>
            <!-- Message End -->
          </a>
          <div class="dropdown-divider"></div>
          <a href="#" class="dropdown-item">
            <!-- Message Start -->
            <div class="media">
              <img src="dist/img/user3-128x128.jpg" alt="User Avatar" class="img-size-50 img-circle mr-3">
              <div class="media-body">
                <h3 class="dropdown-item-title">
                  Nora Silvester
                  <span class="float-right text-sm text-warning"><i class="fas fa-star"></i></span>
                </h3>
                <p class="text-sm">The subject goes here</p>
                <p class="text-sm text-muted"><i class="far fa-clock mr-1"></i> 4 Hours Ago</p>
              </div>
            </div>
            <!-- Message End -->
          </a>
          <div class="dropdown-divider"></div>
          <a href="#" class="dropdown-item dropdown-footer">See All Messages</a>
        </div>
      </li>
      <!-- Notifications Dropdown Menu -->
      <li class="nav-item dropdown">
        <a class="nav-link" data-toggle="dropdown" href="#">
          <i class="far fa-bell"></i>
          <span class="badge badge-warning navbar-badge">15</span>
        </a>
        <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
          <span class="dropdown-item dropdown-header">15 Notifications</span>
          <div class="dropdown-divider"></div>
          <a href="#" class="dropdown-item">
            <i class="fas fa-envelope mr-2"></i> 4 new messages
            <span class="float-right text-muted text-sm">3 mins</span>
          </a>
          <div class="dropdown-divider"></div>
          <a href="#" class="dropdown-item">
            <i class="fas fa-users mr-2"></i> 8 friend requests
            <span class="float-right text-muted text-sm">12 hours</span>
          </a>
          <div class="dropdown-divider"></div>
          <a href="#" class="dropdown-item">
            <i class="fas fa-file mr-2"></i> 3 new reports
            <span class="float-right text-muted text-sm">2 days</span>
          </a>
          <div class="dropdown-divider"></div>
          <a href="#" class="dropdown-item dropdown-footer">See All Notifications</a>
        </div>
      </li>
      <li class="nav-item">
        <a class="nav-link" data-widget="fullscreen" href="#" role="button">
          <i class="fas fa-expand-arrows-alt"></i>
        </a>
      </li>
      <li class="nav-item">
        <a class="nav-link" data-widget="control-sidebar" data-slide="true" href="#" role="button">
          <i class="fas fa-th-large"></i>
        </a>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">AdminLTE 3</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">Alexander Pierce</a>
        </div>
      </div>

      <!-- SidebarSearch Form -->
      <div class="form-inline">
        <div class="input-group" data-widget="sidebar-search">
          <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
          <div class="input-group-append">
            <button class="btn btn-sidebar">
              <i class="fas fa-search fa-fw"></i>
            </button>
          </div>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item">
            <a href="#" class="nav-link">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="index.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Dashboard v1</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="index2.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Dashboard v2</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="index3.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Dashboard v3</p>
                </a>
              </li>
            </ul>
         
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        
      </div><!-- /.container-fluid -->
    </section>

    <section class="content">
      <!-- Vùng header -->
  <div class="container">
    <div class="text-center">
      <h2>F120 - Quản trị Voucher</h2>
    </div>
    <div class="form-group">
      <button class="btn btn-success" id="btn-add-voucher"><i class="fa fa-plus"></i>&nbsp; New voucher</button>
    </div>
  </div>
  <!-- Vouche Data Table -->
  <div class="container">
    <table class="table table-bordered table-striped table-hover" id="voucher-table">
      <thead>
        <tr>
          <th>STT</th>
          <th>ID</th>
          <th>Mã Voucher</th>
          <th>% giảm giá</th>
          <th>Action</th>
        </tr>
      </thead>
    </table>
  </div>
  <!-- Vùng Modal -->

  <!-- Create voucher modal -->
  <div>
    <div id="create-voucher-modal" class="modal fade" tabindex="-1">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">Create new voucher</h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <form>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-create-voucher-code">Voucher code</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-create-voucher-code" name="vouchercodes" placeholder="Voucher code"
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-create-discount">Discount</label>
                </div>
                <div class="col-sm-8">
                  <input type="number" id="input-create-discount" name="discount" placeholder="Discount"
                    class="form-control">
                </div>
              </div>
            </form>
          </div>
          <div class="modal-footer">
            <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">Cancel</button>
            <button class="btn btn-primary" id="btn-create-voucher">Create Voucher</button>
          </div>
        </div>
      </div>
    </div>
  </div>

  <!-- Update voucher modal -->
  <div>
    <div id="update-voucher-modal" class="modal fade" tabindex="-1">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">Update a Voucher</h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <form>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-update-voucher-code">Voucher code</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-update-voucher-code" name="vouchercodes" placeholder="Voucher code"
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-update-discount">Discount</label>
                </div>
                <div class="col-sm-8">
                  <input type="number" id="input-update-discount" name="discount" placeholder="Discount"
                    class="form-control">
                </div>
              </div>
            </form>
          </div>
          <div class="modal-footer">
            <button class="btn btn-secondary" id="btn-update-cancel" data-dismiss="modal">Cancel</button>
            <button class="btn btn-primary" id="btn-update-voucher">Update Voucher</button>
          </div>
        </div>
      </div>
    </div>
  </div>

  <!-- Delete confirm modal -->
  <div>
    <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">Voucher Delete Confirmation</h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <label>Bạn có chắc chắn muốn xóa voucher này không?</label>
          </div>
          <div class="modal-footer">
            <button class="btn btn-danger" id="btn-confirm-delete-voucher">Confirm</button>
            <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
          </div>
        </div>
      </div>
    </div>
  </div>
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  <footer class="main-footer no-print">
    <div class="float-right d-none d-sm-block">
      <b>Version</b> 3.2.0
    </div>
    <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong> All rights reserved.
  </footer>

  <!-- Control Sidebar -->
  <aside class="control-sidebar control-sidebar-dark">
    <!-- Control sidebar content goes here -->
  </aside>
  <!-- /.control-sidebar -->
</div>
<!-- ./wrapper -->

<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>
<!-- AdminLTE for demo purposes -->
<script src="dist/js/demo.js"></script>

<!-- UserList JS -->
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

Import Datatable sau jquery
<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
<meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
  <!-- Data Table-->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

  
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    // Biến toàn cục để lưu trữ id voucher đang đc update or delete. Mặc định = 0;
    var gVoucherId = 0;
  
    const gBASE_URL = "https://630890e4722029d9ddd245bc.mockapi.io/api/v1/vouchers/";
    const gCONTENT_TYPE = "application/json;charset=UTF-8";
  
    // Biến mảng hằng số chứa danh sách tên các thuộc tính
    const gVOUCHER_COLS = ["stt", "id", "voucherCode", "discount", "action"];
  
    // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
    const gVOUCHER_STT_COL = 0;
    const gVOUCHER_ID_COL = 1;
    const gVOUCHER_VOUCHER_CODE_COL = 2;
    const gVOUCHER_DISCOUNT_COL = 3;
    const gVOUCHER_ACTION_COL = 4;
  
    // Biến toàn cục để hiển lưu STT
    var gSTT = 1;
    // Khai báo DataTable & mapping collumns
    var gVoucherTable = $("#voucher-table").DataTable({
      columns: [
        { data: gVOUCHER_COLS[gVOUCHER_STT_COL] },
        { data: gVOUCHER_COLS[gVOUCHER_ID_COL] },
        { data: gVOUCHER_COLS[gVOUCHER_VOUCHER_CODE_COL] },
        { data: gVOUCHER_COLS[gVOUCHER_DISCOUNT_COL] },
        { data: gVOUCHER_COLS[gVOUCHER_ACTION_COL] }
      ],
      columnDefs: [
        { // định nghĩa lại cột STT
          targets: gVOUCHER_STT_COL,
          render: function () {
            return gSTT++;
          }
        },
        { // định nghĩa lại cột action
          targets: gVOUCHER_ACTION_COL,
          defaultContent: `
          <img class="edit-voucher" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
          <img class="delete-voucher" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
        `
        }
      ]
    });
  
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
      // thực hiện tải trang
      onPageLoading();
      // 2 - C: gán sự kiện Create - Thêm mới voucher
      $("#btn-add-voucher").on("click", function () {
        onBtnAddNewVoucherClick();
      });
      // 3 - U: gán sự kiện Update - Sửa 1 voucher
      $("#voucher-table").on("click", ".edit-voucher", function () {
        onBtnEditVoucherClick(this);
      });
  
      // 4 - D: gán sự kiện Delete - Xóa 1 voucher
      $("#voucher-table").on("click", ".delete-voucher", function () {
        onBtnDeleteVoucherClick(this);
      });
  
      // gán sự kiện cho nút Create Voucher (trên modal)
      $("#btn-create-voucher").on("click", function () {
        onBtnCreateVoucherClick();
      });
  
      // gán sự kiện cho nút Update Voucher (trên modal)
      $("#btn-update-voucher").on("click", function () {
        onBtnUpdateVoucherClick();
      });
  
      // gán sự kiện cho nút Confirm trên modal delete
      $("#btn-confirm-delete-voucher").on("click", function() {
        onBtnConfirmDeleteClick();
      })
    });
  
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // hàm thực thi khi trang được load
    function onPageLoading() {
      // 1 - R: Read / Load voucher to DataTable
      getAllVouchers();
    }
  
    // Hàm xử lý sự kiện khi nút Thêm mới đc click
    function onBtnAddNewVoucherClick() {
      // hiển thị modal trắng lên
      $("#create-voucher-modal").modal("show");
    }
  
    // Hàm xử lý sự kiện khi icon edit voucher trên bảng đc click
    function onBtnEditVoucherClick(paramBtnEdit) {
      // lưu thông tin voucherId đang được edit vào biến toàn cục
      gVoucherId = getVoucherIdFromButton(paramBtnEdit);
      // load dữ liệu vào các trường dữ liệu trong modal
      getVoucherById(gVoucherId);
    }
  
    // Hàm xử lý sự kiện khi icon Delete voucher trên bảng đc click
     function onBtnDeleteVoucherClick(paramBtnDelete) {
      // lưu thông tin voucherId đang được delete vào biến toàn cục
      gVoucherId = getVoucherIdFromButton(paramBtnDelete);
      // bật modal confirm lên
      $("#delete-confirm-modal").modal("show");
    }
  
    // hàm xử lý sự kiện create voucher modal click
    function onBtnCreateVoucherClick() {
      // khai báo đối tượng chứa voucher data
      var vVoucherObj = {
        voucherCode: "",
        discount: -1
      };
      // B1: Thu thập dữ liệu
      getCreateVoucherData(vVoucherObj);
      // B2: Validate insert
      var vIsVoucherValidate = validateVoucherData(vVoucherObj);
      if (vIsVoucherValidate) {
        // B3: insert voucher
        $.ajax({
          url: gBASE_URL,
          type: "POST",
          contentType: gCONTENT_TYPE,
          data: JSON.stringify(vVoucherObj),
          success: function (paramRes) {
            // B4: xử lý front-end
            handleInsertVoucherSuccess();
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          }
        });
      }
    }
  
    // hàm xử lý sự kiện update voucher modal click
    function onBtnUpdateVoucherClick() {
      // khai báo đối tượng chứa voucher data
      var vVoucherObj = {
        "voucherCode": "",
        "discount": -1
      };
      // B1: Thu thập dữ liệu
      getUpdateVoucherData(vVoucherObj);
      // B2: Validate update
      var vIsVoucherValidate = validateVoucherData(vVoucherObj);
      if (vIsVoucherValidate) {
        // B3: update voucher
        $.ajax({
          url: gBASE_URL + gVoucherId,
          type: "PUT",
          contentType: gCONTENT_TYPE,
          data: JSON.stringify(vVoucherObj),
          success: function (paramRes) {
            // B4: xử lý front-end
            handleUpdateVoucherSuccess();
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          }
        });
      }
    }
  
    // hàm xử lý sự kiện confirm delete
    function onBtnConfirmDeleteClick() {
      // b1: thu thập dữ liệu (ko có)
      // B2: validate dữ liệu (ko có)
      // b3: gọi api để xóa
      $.ajax({
        url: gBASE_URL + gVoucherId,
        type: "DELETE",
        success: function(paramRes) {
          handleDeleteVoucherSuccess();
        },
        error: function(paramErr) {
          alert("Xóa voucher không thành công");
          $("#delete-confirm-modal").modal("hide");
        }
      });
      // b4: xử lý hiển thị front-end
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // hàm gọi api để lấy all danh sách user đăng ký
    function getAllVouchers() {
      $.ajax({
        url: gBASE_URL,
        type: "GET",
        success: function (paramVouchers) {
          loadDataToVoucherTable(paramVouchers);
        },
        error: function (paramErr) {
          console.log(paramErr.status);
        }
      });
    }
    /** load voucher array to DataTable
     * in: voucher array
     * out: voucher table has data
     */
    function loadDataToVoucherTable(paramVoucherArr) {
      gSTT = 1;
      gVoucherTable.clear();
      gVoucherTable.rows.add(paramVoucherArr);
      gVoucherTable.draw();
    }
  
    // hàm get voucher by id
    function getVoucherById(paramVoucherId) {
      $.ajax({
        url: gBASE_URL + paramVoucherId,
        type: "GET",
        success: function (paramVoucher) {
          showVoucherDataToModal(paramVoucher);
        },
        error: function (paramErr) {
          console.log(paramErr.status);
        }
      });
      // hiển thị modal lên
      $("#update-voucher-modal").modal("show");
    }
  
    // hàm show voucher obj lên modal
    function showVoucherDataToModal(paramVoucher) {
      $("#input-update-voucher-code").val(paramVoucher.voucherCode);
      $("#input-update-discount").val(paramVoucher.discount);
    }
  
    // hàm thu thập dữ liệu để create voucher
    function getCreateVoucherData(paramVoucherObj) {
      paramVoucherObj.voucherCode = $("#input-create-voucher-code").val().trim();
      paramVoucherObj.discount = parseInt($("#input-create-discount").val());
    }
  
    // hàm thu thập dữ liệu để update voucher
    function getUpdateVoucherData(paramVoucherObj) {
      paramVoucherObj.voucherCode = $("#input-update-voucher-code").val().trim();
      paramVoucherObj.discount = parseInt($("#input-update-discount").val());
    }
  
    // hàm validate data
    function validateVoucherData(paramVoucherObj) {
      if (paramVoucherObj.voucherCode === "") {
        alert("Voucher code cần nhập");
        return false;
      }
      if (isNaN(paramVoucherObj.discount)) {
        alert("Discount cần nhập vào phải là số");
        return false;
      }
  
      if (paramVoucherObj.discount < 0 || paramVoucherObj.discount > 100) {
        alert("Discount phải nhập trong khoảng từ 0 đến 100!");
        return false;
      }
  
      return true;
    }
  
    // hàm xử lý hiển thị front-end khi thêm voucher thành công
    function handleInsertVoucherSuccess() {
      alert("Thêm voucher thành công!");
      getAllVouchers(); // load dữ liệu mới ra bảng
      resertCreateVoucherForm();
      $("#create-voucher-modal").modal("hide");
    }
  
    // hàm xử lý hiển thị front-end khi sửa voucher thành công
    function handleUpdateVoucherSuccess() {
      alert("Sửa voucher thành công!");
      getAllVouchers();
      resertUpdateVoucherForm();
      $("#update-voucher-modal").modal("hide");
    }
  
    // hàm xử lý hiển thị front-end khi xóa voucher thành công
    function handleDeleteVoucherSuccess() {
      alert("Xóa voucher thành công!");
      getAllVouchers();
      $("#delete-confirm-modal").modal("hide");
    }
  
    // hàm xóa trắng form create voucher
    function resertCreateVoucherForm() {
      $("#input-create-voucher-code").val("");
      $("#input-create-discount").val("");
    }
  
    // hàm xóa trắng form update voucher
    function resertUpdateVoucherForm() {
      $("#input-update-voucher-code").val("");
      $("#input-update-discount").val("");
    }
  
    // hàm dựa vào button detail (edit or delete) xác định đc id voucher
    function getVoucherIdFromButton(paramButton) {
      var vTableRow = $(paramButton).parents("tr");
      var vVoucherRowData = gVoucherTable.row(vTableRow).data();
      return vVoucherRowData.id;
    }
  
  </script>
</body>

</html>